debug = true
playerImg = nil --just for storage

--Timers
canShoot = true
canShootTimerMax = 0.2
canShootTimer = canShootTimerMax

bulletImg = nil -- Bullet image
bullets = {} --Bullet array

--explode
explodeImg = love.graphics.newImage("assets/explode.png")

--enemies
createEnemyTimerMax = 0.4
createEnemyTimer = createEnemyTimerMax

enemyImg = nil
enemies = {}

--sound
shootsound = love.audio.newSource("assets/gun-sound.wav")
explosound = love.audio.newSource("assets/Explosion.mp3")
bgmbravo = love.audio.newSource("assets/Bravo.mp3")

--checkcollision
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

isAlive = true
score = 0
miss = 10 --enemy pass by

-- background scrolling
posY = 0 -- initializing posY
background = love.graphics.newImage("assets/sky.png")
imageHeight = background:getHeight() -- this is our image height
function printBackground()
  love.graphics.draw(background, 0, posY)
  love.graphics.draw(background, 0, posY - imageHeight)
  
  posY = posY + 1
  
  if posY >= imageHeight  then
  posY = 0
  end
end


function love.load(arg)
  --player's plane
  player = { x = 200, y = 710, speed = 300, img = nil }
  player.img = love.graphics.newImage("assets/plane.png")
  
  --bullets
  bulletImg = love.graphics.newImage("assets/bullet.png")
  
  --enemies
  enemynumber = love.math.random(1, 3)
  enemyImg = love.graphics.newImage("assets/enemy"..enemynumber..".png")
  
end

function love.update(dt)
  bgmbravo:play()
  --for quitting the game
  if love.keyboard.isDown('escape') then
    love.event.push('quit')
  end
  
  -- dead and restart game
  
    if not isAlive and love.keyboard.isDown('r') then
    --remove bullets and enemies
    bullets = {}
    enemies = {}
    --reset timers
    canShootTimer = canShootTimerMax
    createEnemyTimer = createEnemyTimerMax
    -- move player back to default
    player.x = 200
    player.y = 710
    
    --reset gamestate
    miss = 10 
    score = 0
    enemynumber = love.math.random(1, 3)
    enemyImg = love.graphics.newImage("assets/enemy"..enemynumber..".png")
    isAlive = true
  end
  
  --moving players plane
  if isAlive then
    if love.keyboard.isDown('left','a') then
      if player.x > 0 then --不超出左牆
        if love.keyboard.isDown('up','w') then
          if player.y > 0 then--右斜上
            player.y = player.y - (player.speed * dt)
            player.x = player.x - (player.speed * dt)
          end
        elseif love.keyboard.isDown('down','s') then --右斜下
          if player.y < (love.graphics.getHeight() - player.img:getHeight()) then
            player.y = player.y + (player.speed * dt)
            player.x = player.x - (player.speed * dt)
          end
        else
          player.x = player.x - (player.speed * dt)
        end
      end
    elseif love.keyboard.isDown('right','d') then
    if player.x < (love.graphics.getWidth() - player.img:getWidth()) then     --不超出右牆
      if love.keyboard.isDown('up','w') then
          if player.y > 0 then--左斜上
            player.y = player.y - (player.speed * dt)
            player.x = player.x + (player.speed * dt)
          end
        elseif love.keyboard.isDown('down','s') then --左斜下
          if player.y < (love.graphics.getHeight() - player.img:getHeight()) then
            player.y = player.y + (player.speed * dt)
            player.x = player.x + (player.speed * dt)
          end
        else
          player.x = player.x + (player.speed * dt)
        end
        
    end
  elseif love.keyboard.isDown('up','w') then
    if player.y > 0 then -- 不超出上面
      player.y = player.y - (player.speed * dt)
    end
  elseif love.keyboard.isDown('down','s') then
    if player.y < (love.graphics.getHeight() - player.img:getHeight()) then --不超出下面
      player.y = player.y + (player.speed * dt)
    end
  end
end

  
  --bullet
  canShootTimer = canShootTimer - (1 * dt)
  if canShootTimer < 0 then
    canShoot = true
  end
  
  if love.keyboard.isDown('space') and canShoot then
    if not isAlive then
      canShoot = false
    else
      newBullet = {x = player.x + (player.img:getWidth()/2), y = player.y, img = bulletImg}
      table.insert(bullets, newBullet)
      shootsound:play() -- bullet shoot sound
      canShoot = false
      canShootTimer = canShootTimerMax
    end
    
  end
  
  for i, bullet in ipairs(bullets) do
    bullet.y = bullet.y - (250 * dt)
    
    if bullet.y < 0 then
      table.remove(bullets, i)
    end
  end
  
  --enemies
  --Timeout
  createEnemyTimer = createEnemyTimer - (1 * dt)
  if createEnemyTimer < 0 then
    createEnemyTimer = createEnemyTimerMax
    
    -- create enemy
    randomnumber = math.random(10, love.graphics.getWidth() - enemyImg:getWidth())
    newEnemy = { x = randomnumber, y = -10, img = enemyImg }
    table.insert(enemies, newEnemy)
  end
  
  for i, enemy in ipairs(enemies) do
    enemy.y = enemy.y + (200 * dt)
    
    if enemy.y > 850 then
      table.remove(enemies, i)
      miss = miss -1
      if miss == 0 then
        isAlive = false
      end
      
    end
  end
  
  --check collision
  --bullet hit enemy
  for i, enemy in ipairs(enemies) do
    for j, bullet in ipairs(bullets) do
      if CheckCollision(enemy.x, enemy.y, enemy.img:getWidth(), enemy.img:getHeight(), bullet.x, bullet.y, bullet.img:getWidth(), bullet.img:getHeight()) then
        table.remove(bullets, j)
        table.remove(enemies, i)
        explosound:play() -- enemy explode sound
        score = score + 1
      end
    end
    --enemy hit player
    if CheckCollision(enemy.x, enemy.y, enemy.img:getWidth(), enemy.img:getHeight(),player.x, player.y, player.img:getWidth(), player.img:getHeight()) and isAlive then
      table.remove(enemies, i)
      explosound:play()
      isAlive = false
    end
  end
  
end



function love.draw(dt)
  
   --background draw
  printBackground()
  

  --player
  if isAlive then
    love.graphics.draw(player.img, player.x, player.y, 0)
    --score
    love.graphics.print("Score : "..score.."\nMiss :"..miss ,0 , 0)
  else
    love.graphics.print("Press 'R' to restart \n Your score is "..score, love.graphics:getWidth()/2-50, love.graphics:getHeight()/2-10)
    love.graphics.draw(explodeImg, player.x, player.y)
  end
  
  --bullet
  for i, bullet in ipairs(bullets) do
    love.graphics.draw(bullet.img, bullet.x, bullet.y)
  end
  
  --enemies
  for i, enemy in ipairs(enemies) do
    love.graphics.draw(enemy.img, enemy.x, enemy.y, 0)
  end
  
 
  
end